/*

	by Serge FANTINO - fantino@math.unice.fr
	
*/

#ifndef K_INTERFACE_KIT_TOOLS_H
#define K_INTERFACE_KIT_TOOLS_H

#include <View.h>

const rgb_color background_color = ui_color(B_PANEL_BACKGROUND_COLOR);
const rgb_color light_border_color = tint_color(background_color,B_LIGHTEN_MAX_TINT);
const rgb_color dark_border_color = tint_color(background_color,B_DARKEN_3_TINT);
const rgb_color darkest_border_color = tint_color(dark_border_color,B_DARKEN_3_TINT);
const rgb_color text_color= ui_color(B_MENU_ITEM_TEXT_COLOR);

inline void resize_view_to(BView *v,BPoint p)
{
	v->ResizeTo(p.x,p.y);
};

class KExtendable {
public:

	virtual void ExtendBy(float x,float y,bool lock_size_limit=false,BView *source=NULL)=0;
	
};

void extend_view_by(BView *v,float x,float y,bool lock_size_limit=false,BView *source=NULL);

#endif