#include "layout_manager.h"

KParcel::KParcel()
{
	fOwner=NULL;
}

// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

KOwner::KOwner(KParcel *super_parcel,KParcel *parcel)
{
	fSuperParcel=super_parcel;
	fParcel=parcel;
}

KOwner::~KOwner()
{
	if (fParcel!=NULL) delete fParcel;
}
	
void KOwner::SetParcel(KParcel *parcel)
{
	if (fParcel!=NULL) fParcel->fOwner=NULL;
	fParcel=parcel;
	if (fParcel!=NULL) fParcel->fOwner=this;
}

// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

KWarper::KWarper(BView *view,anchor anchor,fill fill,bool expand)
{
	fView=view;
	fAnchor=anchor;
	fFill=fill;
	fExpand=expand;
}

BRect KWarper::Bounds()
{
	return fView->Bounds();
}

BRect KWarper::ReshapeView(BView *root,BRect frame)
{
	if (View()->Parent()==NULL) {
		root->AddChild(View());
	}
	// -- placement,
	
	// -- resizing mode,
	
	// -- resulting cavity.
	
}

void KWarper::ExtendBy(float x,float y,KContainer_virtual *source)
{
	// ???
}
	
void KWarper::GetPreferredContainsSize(float *width,float *height)
{
	fView->GetPreferredSize(width,height);
}

// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


BRect KWarperNode::Bounds()
{
	BRect master_bounds(0,0),slave_bounds(0,0);
	if (Master()->Parcel()!=NULL) master_bounds=Master()->Parcel()->Bounds();
	if (Slave()->Parcel()!=NULL) slave_bounds=Slave()->Parcel()->Bounds();
	if (Posture()==B_HORIZONTAL) 
		return BRect(0,0,max_c(master_bounds.Width(),slave_bounds.Width()),master_bounds.Height()+slave_bounds.Height());
	else
		return BRect(0,0,master_bounds.Width()+slave_bounds.Width(),max_c(master_bounds.Height(),slave_bounds.Height()));
}

BRect KWarperNode::compute_parcel(BRect parcel,BRect cavity,side side)
{
	switch (Side()) {
		case K_SIDE_TOP:
			parcel.OffsetTo(cavity.LeftTop());
			parcel.right=cavity.right;
			break;
		case K_SIDE_BOTTOM:
			parcel.OffsetTo(cavity.LeftBottom()-BPoint(0,parcel.Height()));
			parcel.right=cavity.right;
			break;
		case K_SIDE_LEFT:
			parcel.OffsetTo(cavity.LeftTop());
			parcel.bottom=cavity.bottom;
			break;
		case K_SIDE_BOTTOM:
			parcel.OffsetTo(cavity.RightTop()-BPoint(parcel.Width(),0));
			parcel.bottom=cavity.bottom;
			break;
	}
	return parcel;
}

BRect KWarperNode::Reshape(BView *root,BRect frame)
{
	BRect cavity=frame;
	if (Master()->Parcel()!=NULL) {
		BRect master_parcel=Master()->Parcel()->Bounds();
		master_parcel=compute_parcel(parcel,cavity,Side());
		master_parcel=Master()->Parcel()->Reshape(root,master_parcel);
		if (cavity.Width()<=0||cavity.Height()<=0) return cavity;
	}
	if (Slave()->Parcel()!=NULL) cavity=Slave()->Parcel()->Reshape(root,cavity);
	return cavity;
}

void KWarperNode::ExtendBy(float x,float y,KOwner *source)
{
	if (source==Master()&&source!=NULL) {
	
	} else if (source==Slave()&&source!=NULL) {
	
	}
}
	
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

KPackerView(BRect frame,
		  const char *name,
		  uint32 resizeMask,
		  uint32 flags):
BView(frame,name,resizeMask,flags|B_FRAME_EVENTS),
KOwner(NULL)
{
	fLastOwner=this;
}

KPackerView::~KPackerView()
{
}

KOwner *KPacker::DistributeParcel(KOwner *owner,KWarper *parcel,side side)
{
	KParcel *initial_parcel=owner->Parcel();
	KWarperNode *node=new KWarperNode(parcel,side);
	owner->SetParcel(node);
	node->SetSlaveParsel(initial_parcel);
	return node->Slave();
}
	
KOwner *KPacker::PackChild(BView *view,side side,anchor anchor,fill fill,bool expand)
{
	KWarper *warper=new KWarper(view,anchor,fill,expand);
	fLastOwner=PackChild(LastOwner(),warper,side);
}

KOwner *KPacker::PackChildAfter(KOwner *after,BView *view,anchor anchor,fill fill,bool expand)
{
	KWarper *warper=new KWarper(view,anchor,fill,expand);
	return PackChild(after,warper,side);
}

KOwner *KPacker::PackChild(KOwner *where,KWarper *warper,side side)
{
	KOwner *new_owner=DistributeParcel(where,warper,side)
	
	
}

void KPacker::AttachedToWindow()
{
	// check if it's the first time or something ???
	BRect cavity=Bounds();
	if (Parcel()!=NULL) Parcel()->Reshape(this,cavity);
}
	
void KPacker::FrameResized(float width,float height)
{
	BRect cavity=Bounds();
	if (Parcel()!=NULL) {
		cavity=Parcel()->Reshape(this,cavity);
		// take care of cavity result...
	}
}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
